const { declare } = require('@babel/helper-plugin-utils')

function preset(api, presetOption) {
  api.assertVersion(7)

  const { modules = 'auto', jsx = 'react', macro = true, useBuiltIns } = presetOption || {}

  return {
    presets: [
      [
        require.resolve('@ray-js/babel-preset-base'),
        {
          loose: false,
          targets: { browsers: '> 0.25%, not dead' },
          modules: modules,
          useBuiltIns,
          platform: presetOption.platform,
        },
      ],
      jsx === 'react' && [require.resolve('@babel/preset-react')],
    ].filter(Boolean),
    plugins: [
      jsx === 'preserve' && require.resolve('@babel/plugin-syntax-jsx'),
      macro && require.resolve('babel-plugin-macros'), //  @ray-core/ray 中的 macro 需要
      // require.resolve('babel-plugin-minify-dead-code-elimination'),
      require.resolve('babel-plugin-minify-dead-code-elimination-while-loop-fixed'),
      require.resolve('babel-plugin-transform-prune-unused-imports'),
      [require.resolve('@babel/plugin-proposal-decorators'), { legacy: true }],
      require.resolve('@babel/plugin-proposal-nullish-coalescing-operator'),
      require.resolve('@babel/plugin-proposal-object-rest-spread'),
      require.resolve('@babel/plugin-proposal-optional-chaining'),
    ].filter(Boolean),
  }
}

module.exports = declare(preset)
